;; Apple IIe Robot - Copyright 2019 by Michael Kohn
;; Email: mike@mikekohn.net
;;   Web: http://www.mikekohn.net/
;;
;; Listen to the joystick port of an Apple IIe and read in bits in
;; an SPI-like format.

;; CLOCK: PD5 to An1
;; DATA: PD6 to An0

JOY_CLOCK equ 5
JOY_DATA equ 4

;; r21 = data from joystick port of Apple IIe.
read_joystick_port:
  sbi PORTD, 4
  sbis PINC, JOY_CLOCK   ; if (clock goes high) break;
  rjmp read_joystick_port

  cbi PORTD, 4

  ldi r21, 0     ; current_byte = 0;
  ldi r23, 8     ; bit_count = 8;
read_joystick_bit:

  ;; Wait while line is low
  ldi r28, 0    ; timer
read_joystick_wait_clock_low:
  cpi r28, 5
  brsh read_joystick_port  ; if (r20 longer than ~30ms) abort;
  sbis PINC, JOY_CLOCK     ; if (clock goes low) break;
  rjmp read_joystick_wait_clock_low

  ;; Shift in the bit.
  lsl r21
  sbic PINC, JOY_DATA
  ori r21, 1

  ;; Wait while line is high.
  ldi r28, 0    ; timer
read_joystick_wait_clock_high:
  cpi r28, 5
  brsh read_joystick_port  ; if (r20 longer than ~30ms) abort;
  sbic PINC, JOY_CLOCK     ; if (clock goes low) break;
  rjmp read_joystick_wait_clock_high

  dec r23
  brne read_joystick_bit
  ret

