;; Apple IIe Robot - Copyright 2019 by Michael Kohn
;; Email: mike@mikekohn.net
;;   Web: http://www.mikekohn.net/
;;
;; Read data from a syma helicopter controller.

remote_control_mode:
  rcall ir_comm_read

  lds r17, THROTTLE
  andi r17, 0x7f   ; filter out A/B switch
  cpi r17, 0x38
  brlo motors_off

  lds r17, PITCH

  cpi r17, 0x20
  brsh not_forward
  sbi PORTD, 4
  cbi PORTC, 0
  cbi PORTC, 1
  sbi PORTC, 2
  sbi PORTC, 3
  rjmp remote_control_mode

not_forward:
  cpi r17, 0x50
  brlo not_back
  sbi PORTD, 4
  sbi PORTC, 0
  sbi PORTC, 1
  sbi PORTC, 2
  sbi PORTC, 3
  rjmp remote_control_mode

not_back:
  lds r17, YAW

  cpi r17, 0x20
  brsh not_left
  sbi PORTD, 4
  sbi PORTC, 0
  cbi PORTC, 1
  sbi PORTC, 2
  sbi PORTC, 3
  rjmp remote_control_mode

not_left:
  cpi r17, 0x50
  brlo not_right
  sbi PORTD, 4
  cbi PORTC, 0
  sbi PORTC, 1
  sbi PORTC, 2
  sbi PORTC, 3
  rjmp remote_control_mode

not_right:
motors_off:
  cbi PORTD, 4
  cbi PORTC, 2
  cbi PORTC, 3
  rjmp remote_control_mode

  lds r20, UCSR0A          ; poll uart to see if there is a data waiting
  sbrs r20, RXC0
  rjmp remote_control_mode ; if no data, loop around

