;; uart_hw - Copyright 2018 by Michael Kohn
;; Email: mike@mikekohn.net
;;   Web: http://www.mikekohn.net/
;;
;; Hardware UART routines
;;

; void uart_hw_send(r24)  : r14 trashed
uart_hw_send:
  lds r20, UCSR0A
  sbrs r20, UDRE0
  rjmp uart_hw_send    ; if it's not okay, loop around :)
  sts UDR0, r24        ; output a char over rs232
  ret

uart_hw_init:
  ;; Set up rs232 baud rate
  ldi r17, 0x06
  sts UBRR0H, r17
  ldi r17, 0x82
  sts UBRR0L, r17           ; (8MHz / (16 * 300)) - 1 = 1666 @ 8MHz = 300 baud

  ;; Set up rs232 options
  ldi r17, (1 << UCSZ00) | (1 << UCSZ01)    ; sets up data as 8N1
  sts UCSR0C, r17
  ldi r17, (1 << TXEN0) | (1 << RXEN0)      ; enables send/receive
  sts UCSR0B, r17
  eor r17, r17
  sts UCSR0A, r17
  ret

